#include "DLTest.h"
#include "DLTestManager.h"
#include "DLException.h"
#include <string>
#include <fstream>

using namespace std;

void DLTestManager::addTestCase(DLTest *newTest)
{
	cout << "Loading DLTest environment" << endl;
	cout << "Adding test case " << newTest->getTestName() << endl;
	dlTests.push_back(newTest);
}

int DLTestManager::go()
{
	char testNumber[10];
	sprintf(testNumber, "%u", (int)dlTests.size());
	vector<DLTest*>::iterator iterf;

	string headNote = "\nStart testing with total of " + (string)testNumber + " test cases\n\n";

	for(iterf = dlTests.begin(); iterf != dlTests.end(); iterf++)
	{
		DLTest *test = dynamic_cast<DLTest*>(*iterf);
		if(test != NULL)
		{
			headNote = "***********************************************************\n";
			headNote = headNote + "**Starting Test Case : " + test->getTestName() + "\n";
			headNote = headNote + "***********************************************************\n\n";

			try{
				test->go();
				string testStatus = test->getTestLog();

				// Write the ranked retrieved documents to the output file
				cout << "**End Test Case : " << test->getTestName() << endl;
				cout << "Result = " << test->getResult() << endl;

			}catch(DLException &E)
			{
				cout << E.dlGetErrorMsg() << endl;
				cout << "**End Test Case : " << test->getTestName() << endl;
				cout << "Result = Failed"<< endl;
			}
		}

		else
		{
			throw DLException(DL_NULL_POINTER_EXCEPTION, "Error casting the test case!");
		}
	}

	return 0;
}
