#pragma once
#include <iostream>
#include <string>
#include <map>

using namespace std;
#pragma warning(disable: 4786) 

#define EOL "\r\n" //end of line
static const basic_string <char>::size_type npos = -1;


class xml
{
public:
	xml(void);
	~xml(void);

//Add, Insert an Element and its Data, Get a element with all sub elements
	bool InsertSiblingElem(string strElem, string strData = "" );
	bool InsertChildElem(string strElemName, int level, string strData = "" );
	string GetCurElemName();
	string GetCurElemData();
	string GetCurElemDoc();
	bool DelCurElem( bool bRecursive = 0);

// Add, Set, Delete attributes in Currrent Element
	bool AddDynamicAttrib( map <string, string> tagMap );
	bool AddAttrib(string strAttrib, int nValue);
	bool AddAttrib(string strAttrib, string strValue);
	bool SetAttrib(string strAttrib, int nValue);
	void setXML( string newXML );
	bool SetAttrib(string strAttrib, string strValue);
	bool DelAttrib(string strAttrib);
	string GetAttrib(string strAttrib);
	map <string, string> GetDynamicAttrib( int num );
	string GetAttribName( size_t iEq );


// Navigation
	bool bHasChild();
	bool Go2ChildLevel();
	bool Go2ParentLevel();
	bool GoNextSibling();
	bool GoPrevSibling();
	string RetrieveSpecifiedElem( string strElemName );

// File io
	bool LoadXml(string strFileName);
	bool SaveXml(string strFileName);

private:
	string strXMLDoc;
	size_t curStringIdx;

// Get specific Data
	string GetElemDoc( size_t iPos );
	string GetElemName( size_t iPos );
	string GetElemData( size_t iPos );

// Positions
	size_t GetEndElemPos();//"</...>"
	size_t GetEndElemPos( size_t iPos ); //"</...>"

	size_t GetPrevLeftBracketPos(size_t iPos); //"<"
	size_t GetNextLeftBracketPos(size_t iPos);//"<"

	size_t GetPrevEndBracketPos(size_t iPos); // "</"
	size_t GetNextEndBracketPos(size_t iPos); // "</"

	size_t GetPrevRightBracketPos(size_t iPos); // ">"
	size_t GetNextRightBracketPos(size_t iPos); // ">"
	
	size_t GetPrevQuotePos(size_t iPos); // "\""
	size_t GetNextQuotePos(size_t iPos); // "\""

	size_t GetNextSpacePos(size_t iPos);// " "
	size_t GetPrevSpacePos(size_t iPos);// " "

	size_t GetNextEqualSignPos(size_t iPos); // "="
};
