#include "svm.h"
#include <string>
#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

class DLClassifier
{
public:
	int test(vector<double> testdata);
	DLClassifier();
	DLClassifier(string model_filename, bool bTraining = 1);
	int batchTraining(vector< vector<double> > data, vector<int> dataclass, vector<int> training);
	vector< vector<double> > batchTesting(vector< vector<double> > data, vector<int> dataclass, vector<int> training);
	~DLClassifier();
	int saveConfusionMatrix(string strFileName);

private:

	struct svm_parameter param;		// set by parse_command_line
	struct svm_problem prob;		// set by read_problem
	struct svm_model *model;
	struct svm_node *x_space;
	int cross_validation;
	int nr_fold;
	const char *error_msg;

	string model_file_name;

	vector< vector<double> > confusionMatrix;
};
