#ifndef _DLSIGNATUREDETECTBATCHTEST_H
#define _DLSIGNATUREDETECTBATCHTEST_H

#include "DLTest.h"
#include "DLZone.h"
#include <string>

/**
 * \class DLSignatureDetectBatchTest
 *
 * \brief DLSignatureDetectBatchTest is a command line application that runs the signature detector on a list of document
 * images specified by the user.
 *
 * Its command line syntax is:
 * <p>SignatureDetectDriver [-x] [-l] filename</p>
 *
 * <p>The list of command line arguments are as follows:<br>
 *  -x  ---  Create xml output for each input document<br>
 *  -l  ---  File containing the list of input images to execute<br>
 *  -h  ---  Show help at command line<br>
 * </p><br>
 */

class DLSignatureDetectBatchTest : public DLTest
{
public:

	/**
	* DLSignatureDetectBatchTest
	* \param name The test id name given to the DLSignatureDetectBatchTest
	* \param argc Number of command line arguments
	* \param argv Array of command line arguments
	*/
	DLSignatureDetectBatchTest(char* name, int argc, char** argv);
    
	/**
	* Default DLSignatureDetectBatchTest Destructor
	*/
	~DLSignatureDetectBatchTest(void);

	/**
	* The Main function of DLSignatureDetectBatchTest
	*/
	int go();

	/**
	* Show help information at the command line
	*/
	void showHelp();

};

#endif
