#ifndef _DLPOLYGONSHAPE_H_
#define _DLPOLYGONSHAPE_H_

#include "DLShape.h"
/** \cond **/

/**
 * \brief Polygon shape object 
 *
 * DLPolygonShape class is drived from DLShape to represent a 
 * polygon shape object. 
 *
 * This class is not fully implemented.
 */
class DLPolygonShape : public DLShape
{
   public:
   /**
    * Default DLPolygonShape Constructor that takes in an
    * array of DLPoints.
    * /param array a list of points that makes up the 
    * polygon shape.
    */
   DLPolygonShape(DLPoint* array);
   /**
    *  DLPolygonShape Copy  Constructor
    *  \param orig DLPolygonShape to be copied
    */
   DLPolygonShape(const DLPolygonShape & orig);

   /**
    *  Asignment operator
    *  \param right DLPolygonShape to be copied
    */
   const DLPolygonShape & operator=(const DLPolygonShape & right);

   /**
    * Default DLPolygonShape Destructor
    */
   virtual ~DLPolygonShape() { };


   /**
    * Draws the polygon shape onto a DLImage
    * /param image DLImage* to draw onto
    */
   void  dlDrawShape(DLImage* image);

   protected:
   ///points in the polygon
   DLPoint* array;		

   /// filled or not
   bool fillFlag;		

   /// number of points in the polygon
   int numofPoints;
};  

/** \endcond **/
#endif
